// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// CircleCheckDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "CircleCheck.h"
#include "CircleCheckDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleCheckDlg _CAO

CCircleCheckDlg::CCircleCheckDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCircleCheckDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCircleCheckDlg)
	m_circlecenterx = _T("");
	m_circlecentery = _T("");
	m_circleradius = _T("");
	m_averagedensity = _T("");
	m_executetime = _T("");
	m_standard = 128;
	m_tolerance = 20;
	m_judge = _T("??");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_blnVideoOpened = false;
}

void CCircleCheckDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCircleCheckDlg)
	DDX_Text(pDX, IDC_CIRCLECENTERX, m_circlecenterx);
	DDX_Text(pDX, IDC_CIRCLECENTERY, m_circlecentery);
	DDX_Text(pDX, IDC_CIRCLERADIUS, m_circleradius);
	DDX_Text(pDX, IDC_AVERAGEDENSITY, m_averagedensity);
	DDX_Text(pDX, IDC_EXECUTETIME, m_executetime);
	DDX_Text(pDX, IDC_STANDARD, m_standard);
	DDX_Text(pDX, IDC_TOLERANCE, m_tolerance);
	DDX_Text(pDX, IDC_JUDGE, m_judge);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCircleCheckDlg, CDialog)
	//{{AFX_MSG_MAP(CCircleCheckDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_RECALC, OnRecalc)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleCheckDlg bZ[W nh

BOOL CCircleCheckDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no ;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_CheckCircle.CreateInstance( __uuidof( FvCircle ) ); 
		m_LastMousePoint.CreateInstance( __uuidof( FvPoint ) ); 

		// J荞ݖ
		GetDlgItem(IDC_GRAB)->EnableWindow( FALSE );
		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImage);

		// ͈͂̏lݒ(摜̑Sʂɐݒj
		m_CheckCircle->Putx( 100 );
		m_CheckCircle->Puty( 100 );
		m_CheckCircle->Putradius( 50 );

		// ϔZxlvZ
		Recalc();

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep(350);

            // GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize(m_FvxImage);

			try	{

				// 捞
				m_FvxVideo->GrabSync(m_FvxImage);

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// J荞ݗL
			GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;

		}

		// 摜̕\
		m_FvxDisplayEx->DrawImage(m_FvxImage);

		// ͈͂̏lݒ(摜̑Sʂɐݒj
		m_CheckCircle->Putx( 100 );
		m_CheckCircle->Puty( 100 );
		m_CheckCircle->Putradius( 50 );

		// ϔZxlvZ
		Recalc();


	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CCircleCheckDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CCircleCheckDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CCircleCheckDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// ϔZxvZ
void CCircleCheckDlg::Recalc()
{
    
    UpdateData(TRUE);
	
	// ϒl𑪒肷͈͂ŕ\
    m_FvxDisplayEx->ClearOverlay( -1 );
    m_FvxDisplayEx->PutPenColor( 0xFF0000 );
    m_FvxDisplayEx->DrawData( 0, m_CheckCircle );
    
    m_circlecenterx.Format("%.f" , m_CheckCircle->Getx() );
    m_circlecentery.Format("%.f" , m_CheckCircle->Gety() );
    m_circleradius.Format("%.f" , m_CheckCircle->Getradius() );
    
    // ԌvJn
    m_FvxPerformanceCounter->StartCount();
    
    // C[W̐擪AhX擾
    long lngImageAddress = 0;
    m_FvxImage->GetImageAdrs( &lngImageAddress , 0 );
    
    // ~̕ϒlCircleAreaAverageŌvZ
	double dblAve = CircleAreaAverage(lngImageAddress, m_FvxImage->GetImageWidth(),
		m_FvxImage->GetImageHeight(), m_FvxImage->GetBitPerPixel(), ( long )m_CheckCircle->Getx(), ( long )m_CheckCircle->Gety(), ( long )m_CheckCircle->Getradius() );
        
    // ԌvI
    double dblTime = 0;
	m_FvxPerformanceCounter->StopCount( &dblTime );
    
    if ( dblAve == -1 ) {
        m_averagedensity = "G[" ;
    } else {
        m_averagedensity.Format("%.2f", dblAve );
        Judge( dblAve );
	}
		
    m_executetime.Format("%.2f", dblTime );
    
	UpdateData( FALSE );

}

// OK/NG
void CCircleCheckDlg::Judge(double dblAve)
{

    
    // (l-e)  ~  (l+e) ȂOK
    if ((( m_standard - m_tolerance ) < dblAve) && (( m_standard + m_tolerance ) > dblAve)) {
        m_judge = "n@j";
    } else {
        m_judge = "m@f";
	}

	UpdateData( FALSE );

}

void CCircleCheckDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CWnd *pwndlabel;
			CRect rect;
			CRect rectlabel;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			pwndlabel = GetDlgItem( IDC_INFO );
			pwndlabel->GetWindowRect( rectlabel );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );
			ScreenToClient( rectlabel );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );
			pwndlabel->MoveWindow( rectlabel.left , rect.Height() + 15,rectlabel.Width(), rectlabel.Height() , TRUE );
		}
	}	
}

// 摜t@CǍ
void CCircleCheckDlg::OnLoadimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

		// 摜^Cv`FbN
		if (( m_FvxImage->GetImageType ()!= imageGray ) || ( m_FvxImage->GetBitPerPixel()!= 8 ) || 
			( m_FvxImage->GetImageWidth ()!= 512 ) || ( m_FvxImage->GetImageHeight()!= 480 )) {

			MessageBox("512*480 8bitOC̉摜ł͂܂","G[", MB_ICONWARNING | MB_OK);

            m_FvxImage->PutBitPerPixel( 8 );
            m_FvxImage->PutImageType( imageGray );
            m_FvxImage->PutImageWidth( 512 );
            m_FvxImage->PutImageHeight( 480 );
		}

        m_FvxDisplayEx->DrawImage( m_FvxImage );

		// ϔZxlvZ
		Recalc();

	}

}

// 摜t@Cۑ
void CCircleCheckDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage );
		
		} catch(_com_error ) {

			long lngErr;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// 荞
void CCircleCheckDlg::OnGrab() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage );
    
    // 捞
    m_FvxVideo->GrabSync( m_FvxImage );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage );
    
    // ϒľvZ
    Recalc();
}

// ČvZ{^
void CCircleCheckDlg::OnRecalc() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	Recalc();
}

BEGIN_EVENTSINK_MAP(CCircleCheckDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CCircleCheckDlg)
	ON_EVENT(CCircleCheckDlg, IDC_FVXDISPLAYEX1, 1 /* MouseDown */, OnMouseDownFvxdisplayex1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	ON_EVENT(CCircleCheckDlg, IDC_FVXDISPLAYEX1, 3 /* MouseMove */, OnMouseMoveFvxdisplayex1, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

// FvxDisplayŃ}EX̃{^ƂɔCxg
void CCircleCheckDlg::OnMouseDownFvxdisplayex1(long Button, long Shift, long X, long Y, long InOut) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    if ( Button == 1 ) {

        // ~}EXJ[\̈ʒuֈړ
        m_CheckCircle->Putx( X );
        m_CheckCircle->Puty( Y );
        
        // S摜̈撆OȂ悤ɃNbv
        if ( m_CheckCircle->Getx() < 0 )  m_CheckCircle->Putx( 0 );
        if ( m_CheckCircle->Gety() < 0 )  m_CheckCircle->Putx( 0 );
        if ( m_CheckCircle->Getx() >= m_FvxImage->GetImageWidth() )  m_CheckCircle->Putx( m_FvxImage->GetImageWidth() - 1 );
        if ( m_CheckCircle->Gety() >= m_FvxImage->GetImageHeight() ) m_CheckCircle->Puty( m_FvxImage->GetImageHeight() - 1 );
    
        Recalc();
        
    } 
	if ( Button == 2 )  {
        // ݂̃}EXJ[\ʒuۑ
        m_LastMousePoint->Putx( X );
        m_LastMousePoint->Puty( Y );
	}
		
}

// }EXFvxDisplayňړƂɔCxg
void CCircleCheckDlg::OnMouseMoveFvxdisplayex1(long Button, long Shift, long X, long Y, long InOut) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if ( Button == 1 ) {
		
		// ~}EXJ[\̈ʒuֈړ
        m_CheckCircle->Putx( X );
        m_CheckCircle->Puty( Y );
    
        // S摜̈撆OȂ悤ɃNbv
        if ( m_CheckCircle->Getx() < 0 )  m_CheckCircle->Putx( 0 );
        if ( m_CheckCircle->Gety() < 0 )  m_CheckCircle->Puty( 0 );
        if ( m_CheckCircle->Getx() >= m_FvxImage->GetImageWidth() )  m_CheckCircle->Putx( m_FvxImage->GetImageWidth() - 1 );
        if ( m_CheckCircle->Gety() >= m_FvxImage->GetImageHeight() ) m_CheckCircle->Puty( m_FvxImage->GetImageHeight() - 1 );
    
        Recalc();
	}
    if ( Button == 2 ) {
        
        // Õ}EXJ[\ʒüړʂ𔼌aɉZ
        double dblRadius = m_CheckCircle->Getradius() + X - m_LastMousePoint->Getx();
        if ( dblRadius < 3 ) dblRadius = 3 ;
        m_CheckCircle->Putradius( dblRadius );
        
		// }EXJ[\ʒuXV
        m_LastMousePoint->Putx( X );
        m_LastMousePoint->Puty( Y );
        
        Recalc();
	}	
}

void CCircleCheckDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	// rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}

BOOL CCircleCheckDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}	
	}	
	return CDialog::PreTranslateMessage(pMsg);
}

/* ------------------------------------------------------------------------
	double CircleAreaAverage
		w~̈̉f̕ϔZx߂܂B
		8bitOC摜płB

	
		long lImageAddres	摜̐擪AhX
		long lImageSizeX	摜XTCY
		long lImageSizeY	摜YTCY
		long lImageBPP		摜BPPl
		long lsx		ς߂~̈̒SXW
		long lsy		ς߂~̈̒SYW
		long lradius	ς߂~̈̔a
	Ԓl
		IF@߂ꂽϔZxl
		ُIF@-1
 ------------------------------------------------------------------------- */
double CCircleCheckDlg::CircleAreaAverage(long lImageAddress, long lImageSizeX, long lImageSizeY, long lImageBPP, long lcx, long lcy, long lradius)
{
	unsigned char *pImage;		// ڂĂf̃AhX
	unsigned char *pLineTop;
	long i,j;

	RECT rc;						// ~̊Oڐ`
	long lRectSizeX, lRectSizeY;	// Oڐ`̑傫
	long lSqrRadius;				// âQ

	long lx, ly;		// ڂĂf̍W
	long lSum=0;		// ϒlof̘a
	long lPixelNum=0;	// lSumŉZf

	// BPP8ȊOُ͈̎I
	if( lImageBPP != 8 ) return -1;

	// ~̊Oڐ`߂
	rc.left = lcx - lradius;
	rc.top = lcy - lradius;
	rc.right = lcx + lradius;
	rc.bottom = lcy + lradius;
	// ̈悪摜Ƃ܂dȂĂȂꍇُ͈I
	if( (rc.right < 0) | (rc.left >= lImageSizeX) ) return -1;
	if( (rc.bottom < 0) | (rc.top >= lImageSizeY) ) return -1;

	// ͂ݏoĂ镔NbsO
	rc.left = (rc.left < 0) ? 0 : rc.left;
	rc.top = (rc.top < 0) ? 0 : rc.top;
	rc.right = (rc.right >= lImageSizeX) ? lImageSizeX-1 : rc.right;
	rc.bottom = (rc.bottom >= lImageSizeY) ? lImageSizeY-1 : rc.bottom;

	// ̈̃TCYZo
	lRectSizeX = rc.right - rc.left + 1;
	lRectSizeY = rc.bottom - rc.top + 1;
	
	// 󂯎AhXl|C^
	pImage = (unsigned char*)lImageAddress;

	// 炩ߔâQ߂Ă
	lSqrRadius = lradius * lradius;

	// Oڐ`̍Ɉړ
	pImage += lImageSizeX * rc.top + rc.left;
	lx = rc.left; ly = rc.top;

	for( j=0; j<lRectSizeY; j++ ){
		pLineTop = pImage;				// 擪ʒuۑ

		for( i=0; i<lRectSizeX; i++ ){
			// O̒藝𗘗p~̓
			if( (lcx-lx)*(lcx-lx)+(lcy-ly)*(lcy-ly) <= lSqrRadius ){
				lSum += *pImage; lPixelNum++;
			}
			pImage++; lx++;
		}

		pImage = pLineTop + lImageSizeX;	// ̍s
		lx = rc.left; ly++;
	}

	return (double)lSum / (double)lPixelNum;

}
